
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import javax.swing.JPanel;
import javax.swing.JComponent;

/**
 * A component that draws two rectangles.
 */
public class RectangleComponent extends JComponent {

    public void paintComponent(Graphics g) {
        // Recover Graphics2D
        Graphics2D g2 = (Graphics2D) g;

        // Construct a rectangle and draw it
        Rectangle box1 = new Rectangle(5, 10, 70, 150);
        g2.draw(box1);

        // Construct another rectangle and draw it
        Rectangle box2 = new Rectangle(50, 80, 70, 150);
        g2.draw(box2);

        // Find the intersection of these two rectangles, then translate and draw it
        Rectangle box3 = box1.intersection(box2);
        box3.translate(120, 150);
        g2.fill(box3);

    }
}
